#include "lk_long.h"
#include "shared_peel.h"

#define FILL_LIMIT 50.0
#define OP_SAMPLING 128

#define SAMPLED_MAT 128
#define SAMPLED_PAT 256

#define MARKER_SAMPLED 128
#define RFMASK_OK 256
#define TL_UNLINKED 1
#define TL_LINKED 2
#define TL_LINKABLE 4

struct R_Func
{
	int n_ind;
	int n_terms;
	lk_ulong mask[2];
	int mask1[2];
	double fill;
	int *id_list;
	lk_ulong *index;
	double *p;
	int flag;
};

struct hash_element
{
	struct hash_element *left,*right;
	lk_ulong index;
	double p;
};

struct hash_block
{
	struct hash_block *next;
	struct hash_element *elements;
	int size,ptr;
};

struct peel_mem_block
{
	struct peel_mem_block *next;
	lk_ulong *index;
	double *val;
	size_t size,ptr;
};

struct fset
{
	double p;
	char pat_gene[2];
	char mat_gene[2];
};

typedef void pen_func(double *val,int id,int locus,int n_all,int n_bits);

extern pen_func penetrance;

extern struct R_Func ***r_func;
extern int ***allele_trans;
extern unsigned long ***all_set,**req_set[2];
extern struct Peelseq_Head **peelseq_head;
extern int si_mode,max_peel_off;

extern double peel_locus(const int *,int,int,int);
extern double seg_pen(int,int,int *,int);
extern void meiosis_scan(int);
extern int pass_founder_genes1(const int,const int,const int);
extern int pass_founder_genes(const int,const int);
extern int cmp_loci_pos(const void *,const void *);
extern void seg_alloc(void),seg_dealloc(void),free_complex_mem(void);
extern void peel_alloc(void),peel_dealloc(void);
extern void get_locuslist(int *,const int,int *);
