/****************************************************************************
 *                                                                          *
 *     Loki - Programs for genetic analysis of complex traits using MCMC    *
 *                                                                          *
 *             Simon Heath - Rockefeller University                         *
 *                                                                          *
 *                       November1997                                       *
 *                                                                          *
 * loki_tlmoves.h:                                                          *
 *                                                                          *
 * Defines for move probabilities                                           *
 *                                                                          *
 ****************************************************************************/

#define BIGMOVE_PROB .25
#define SMALLMOVE_P 0.5

#define BETA_A 5.75
#define BETA_B 1.25

#define BIRTH_STEP 0.5
#define DEATH_STEP 0.5
#define SPLIT_STEP 0.0
#define COMBINE_STEP 0.0

#define PROP_RATIO 0.1

extern void Sample_LinkageGroup(const int);
extern void Sample_TL_Position(const int);
extern void Sample_TL_Dom(const int);
extern void TL_Birth_Death(void);
extern void TL_Alloc(void),TL_Free(void);
extern double calc_tl_like(const int,int *,const int);
