#define HAP_DAT 512
#define HAP_JNT 1024
#define IN_RF 2048
#define HAD_M 4096
#define HAD_P 8192

#define X_MAT 0
#define X_PAT 1

#define X_MM_PM 0
#define X_MM_PP 1
#define X_MP_PM 2
#define X_MP_PP 3

#define HASHTABLE_SIZE 2053  /* Should be prime */

#define PEEL_SIMPLE 1
#define PEEL_COMPLEX 2

#define TL_NAME "#traitlocus#"

union Peelseq_Pointer {
	struct Complex_Element *complex;
	struct Simple_Element *simple;
};

struct Peelseq_Head {
	union Peelseq_Pointer ptr;
	int type;
};

struct Simple_Element {
	struct Peelseq_Head next;
	int sire;
	int dam;
	int n_off;
	int pivot;
	int out_index;
	int *off;
};

struct Complex_Element {
	struct Peelseq_Head next;
	int n_peel;              /* No. alleles to be peeled */
	int n_involved;          /* No. alleles involved in the operation */
	int out_index;           /* Index of output R-Function */
	int n_rfuncs;            /* How many R-Functions to be combined */
	int *involved;           /* ids of above (i>0 - maternal allele of i, i<0 - paternal allele of -i) */
	int *flags;              /* Flags for involved alleles */
	int *index;              /* Indices for R-Functions */
};

void free_peelseq(struct Peelseq_Head *pp);
extern int num_bits(const int n_all);
